new;
library qam,pgraph,optmum;

cls;

let sigma = 0.15 0.15 0.05;
let mu =    0.10 0.10 0.05;
let rho = 1.00 
          0.50 1.00
          0.20 0.20 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

phi0 = 0;
A = ones(1,3); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(3,1);
{x0,sigma0,retcode} = Qprog_Min_Variance(cov,A,B,C,D,Bounds);
{x1,mu1,sigma1,phi1,retcode1} = Qprog_Allocation_Solve(mu,cov,A,B,C,D,Bounds,0.05,2);
{x2,mu2,sigma2,phi2,retcode2} = Qprog_Allocation_Solve(mu,cov,A,B,C,D,Bounds,0.10,2);
print ftosa(100*(x0~x1~x2),"%lf",3,2);
print ftosa(phi0~phi1~phi2,"%lf",3,6);

A = ones(1,3); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(3,1); Bounds[1,1] = 0.08;
{x0,sigma0,retcode} = Qprog_Min_Variance(cov,A,B,C,D,Bounds);
{x1,mu1,sigma1,phi1,retcode1} = Qprog_Allocation_Solve(mu,cov,A,B,C,D,Bounds,0.05,2);
{x2,mu2,sigma2,phi2,retcode2} = Qprog_Allocation_Solve(mu,cov,A,B,C,D,Bounds,0.10,2);
print ftosa(100*(x0~x1~x2),"%lf",3,2);
print ftosa(phi0~phi1~phi2,"%lf",3,6);

// Calcul du lagrangien par le programme primal
A = ones(1,3); B = 1; C = 1~0~0; D = 0.08; Bounds = (0~1) .* ones(3,1); 
{x0,u1,lagr0,u3,u4,retcode0} = QProg(x0,2*cov,phi0*mu,A,B,C,D,Bounds);
{x1,u1,lagr1,u3,u4,retcode0} = QProg(x0,2*cov,phi1*mu,A,B,C,D,Bounds);
{x2,u1,lagr2,u3,u4,retcode0} = QProg(x0,2*cov,phi2*mu,A,B,C,D,Bounds);  
print; 
print ftosa(lagr0~lagr1~lagr2,"%lf",3,6);

// Calcul du lagrangien par le programme dual
S = -C|A|-A|-eye(3); T = -D|B|-B|zeros(3,1);
// S = -S; T = -T;
Bounds = (0~10) .* ones(6,1);
Q_tilde = 0.5*S*invpd(cov)*S';
R_tilde = 0.5*phi0*S*invpd(cov)*mu - T;
{lambda0,u1,u2,u3,u4,retcode0} = QProg(zeros(6,1),Q_tilde,R_tilde,0,0,0,0,Bounds);
R_tilde = 0.5*phi1*S*invpd(cov)*mu - T;
{lambda1,u1,u2,u3,u4,retcode0} = QProg(zeros(6,1),Q_tilde,R_tilde,0,0,0,0,Bounds);
R_tilde = 0.5*phi2*S*invpd(cov)*mu - T;
{lambda2,u1,u2,u3,u4,retcode0} = QProg(zeros(6,1),Q_tilde,R_tilde,0,0,0,0,Bounds);
print ftosa(lambda0[1]~lambda1[1]~lambda2[1],"%lf",3,6);

A = ones(1,3); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(3,1); Bounds[1,1] = 0.20;
{x0,sigma0,retcode} = Qprog_Min_Variance(cov,A,B,C,D,Bounds);
print ftosa(100*sigma0,"Lower bound of the volatility = %lf",3,2);

sigma1 = sigma[1]; sigma2 = sigma[2]; sigma3 = sigma[3];
rho12 = rho[1,2]; rho13 = rho[1,3]; rho23 = rho[2,3];
d = (sigma2^2 - 2*rho23*sigma2*sigma3 + sigma3^2);
a = (sigma3^2 - rho23*sigma2*sigma3)/d;
b = (sigma2^2 - rho23*sigma2*sigma3)/d;
c = (sigma1 *(rho12 * sigma2 - rho13 * sigma3))/d;
alpha = sigma1^2 + (a+c)^2 * sigma2^2 + (b-c)^2 * sigma3^2 - 2*(a+c)*rho12*sigma1*sigma2 -
        2*(b-c)*rho13*sigma1*sigma3 + 2*(a+c)*(b-c)*rho23*sigma2*sigma3;
beta =  a*rho12*sigma1*sigma2 + b*rho13*sigma1*sigma3 - 
        (a*(b-c)+b*(a+c))*rho23*sigma2*sigma3 - a*(a+c)*sigma2^2 - b*(b-c)*sigma3^2;
gamma_ = a^2 * sigma2^2 + b^2 * sigma3^2 + 2*a*b*rho23*sigma2*sigma3;

sigma_star = 0.05;
xi = real(polyroot(alpha|2*beta|(gamma_-sigma_star^2)));
print ftosa(100*xi,"Solutions = %lf",3,5);
