new;
library qam,tsm,optmum,pgraph;

__output = 0;

k = seqa(0,1,11);
n = 100;
m = 1000;

d = -0.3;
{phi1,theta1,retcode} = canonical_arfima(d,0,0,m,n);

d = 0.3;
{phi2,theta2,retcode} = canonical_arfima(d,0,0,M,N);

Results = theta1~phi1~theta2~phi2;
Results = Results[1:11,.]';
print ftosa(Results,"%lf",3,3);

d = 0.3;
k = seqa(0,1,10);
if d < 0;
  phi = exp(lnfact(k-d-1))./exp(lnfact(k))./exp(lnfact(-d-1));
  theta = (exp(lnfact(k+d))./(k+d))./exp(lnfact(k))./(exp(lnfact(d))/d);
else;
  phi = (exp(lnfact(k-d))./(k-d))./exp(lnfact(k))./(-exp(lnfact(-d))/d);
  theta = exp(lnfact(k+d-1))./exp(lnfact(k))./exp(lnfact(d-1));
endif;

print ftosa(theta'|phi',"%lf",3,3);

datFileName = "data";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
let string selected_names = "date" "euribor" "bnp" "casa" "natixis" "sg";
indx = indsav(selected_names,vnames);
data = data[.,indx];
data = Fill_Miss(data,4);
Data = selif(Data,(Data[.,1] .>= 19981231) .and (Data[.,1] .<= 20091231));

Dates = Data[.,1];
nDates = rows(Dates);
Libor = Data[.,2];

Stocks = Data[.,3:6];
nStocks = cols(Stocks);

Basket = Stocks[.,1 2 3 4];
R_Basket = Basket./lag1(basket) - 1.0;
R_Basket_Multi = (R_Basket[.,1] - R_Basket[.,2]) ~ 
                 (R_Basket[.,1] - R_Basket[.,3]) ~ 
                 (R_Basket[.,1] - R_Basket[.,4]) ~ 
                 (R_Basket[.,2] - R_Basket[.,3]) ~ 
                 (R_Basket[.,2] - R_Basket[.,4]) ~ 
                 (R_Basket[.,3] - R_Basket[.,4]) ;
R_Basket = R_Basket[.,1 4]~(R_Basket[.,1] - R_Basket[.,4]);

pLags = 260;
pAR = 100;

Stats = zeros(nDates,3);
Weights = zeros(nDates,3);

Stats_Multi = zeros(nDates,6);
Weights_Multi = zeros(nDates,6);

/*

i = 1;
do until i > nDates;

  if i < pLags + 1;
    i = i + 1;
    continue;
  endif;

// Questions 4 et 5

  data = R_basket[i-pLags:i,.];

  j = 1;
  do until j > 3;

    y = packr(data[.,j]);

    if rows(y) < 0.75*plags;
      j = j + 1;
      continue;
    endif;

    Rt = submat(rev(y),seqa(1,1,pAR),1);

    sv = 0|stdc(y);
    {theta,stderr,Mcov,logl} = arfima(y,0,0,sv,0|0);
    d = theta[3];
    Stats[i,j] = d;

    {phi,theta,retcode} = canonical_arfima(d,0,0,1000,100);
    phi = trimr(phi,1,0);
    y_forecast = sumc(phi .* Rt);

    Weights[i,j] = y_forecast; 

    j = j + 1;
  endo;

// Question 6

  data = R_basket_Multi[i-pLags:i,.];

  j = 1;
  do until j > 6;

    y = packr(data[.,j]);

    if rows(y) < 0.75*plags;
      j = j + 1;
      continue;
    endif;

    Rt = submat(rev(y),seqa(1,1,pAR),1);

    sv = 0|stdc(y);
    {theta,stderr,Mcov,logl} = arfima(y,0,0,sv,0|0);
    d = theta[3];
    Stats_Multi[i,j] = d;

    {phi,theta,retcode} = canonical_arfima(d,0,0,1000,100);
    phi = trimr(phi,1,0);
    y_forecast = sumc(phi .* Rt);

    Weights_Multi[i,j] = y_forecast; 

    j = j + 1;
  endo;

  if i%100 == 0;
    print ftosa(Dates[i],"date  = %lf",1,0);
  endif;

  i = i + 1;
endo;

save stats;
save weights;

save stats_Multi;
save weights_Multi;

*/

loadm weights;
loadm weights_Multi;

indx = selif(seqa(1,1,nDates),Dates .>= 19991231);
Dates = Dates[indx];
nDates = rows(Dates);
Libor = Libor[indx];
Weights = Weights[indx,.];
R_basket = R_basket[indx,.];

Weights_Multi = Weights_Multi[indx,.];
R_basket_Multi = R_basket_Multi[indx,.];

Libor_Index = Compute_Capitalized_Eonia(Dates,Libor);
R_Libor = Libor_Index./lag1(Libor_Index) - 1.0;

Weights = 50*Weights;
Rt = lagn(R_basket,-1);
Weights = missrv_substute(Weights,Rt .== error(0),0);
Weights = missrv(Weights,0.0);
R_St = missrv_substute(Weights .* Rt,Rt .== error(0),0) + (1-Weights) .* R_Libor;
R_St[1,.] = zeros(1,3);
St = 100*cumprodc(1 + R_St);
S_Basket = St;

Weights_Multi = 50*Weights_Multi;
Rt = lagn(R_basket_Multi,-1);
Weights_Multi = missrv_substute(Weights_Multi,Rt .== error(0),0);
Weights_Multi = missrv(Weights_Multi,0.0);
R_St = sumr(missrv_substute(Weights_Multi .* Rt,Rt .== error(0),0)) + (1-sumr(Weights_Multi)) .* R_Libor;
R_St[1] = 0;
St = 100*cumprodc(1 + R_St);
S_Basket = S_Basket ~ St;

t = seqa(1,1,nDates);
data = t~Libor_Index~S_Basket;
data[.,2:cols(data)] = data[.,2:cols(data)] ./ data[1,2:cols(data)] * 100;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|2|3|4; _pgrid = {3,1};
  xtics(1,nDates,260,2);
  ytics(100,500,100,2);
  let xlab = "2000" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10";
  _plegstr = "Euribor\000BNP\000SG\000BNP / SG\000MULTI";
  _plegctl = {2 5 1.25 4.75};
  asclabel(xlab,0);
  xy(data[.,1],data[.,2:cols(data)]);

Results = zeros(4,4);
i = 1;
do until i > 4;
  report = Compute_Global_Reporting(Dates,S_Basket[.,i],0,Libor_Index,0,0);
  Results[.,i] = 100*vread(report,"mu") |
                 100*vread(report,"sigma") |
                 vread(report,"SR") |
                 100*vread(report,"mDD") ;
  i = i + 1;
endo;

print ftosa(Results,"%lf",2,2);
