new;
library qam,tsm,optmum,pgraph;
TSMset;

rndseed 123;

phi1 = 0.75; theta1 = 0.2; sigma_u = 1; sigma_v = 0.5;

n = 1000;
u = rndn(n,1)*sigma_u;
x = recserar(u,0,phi1);
v = rndn(n,1)*sigma_v;
y = v - theta1*lag1(v); y[1] = v[1];
z = x + y;

{lambda,I} = PDGM(z);

sv = 0.75|1|0.2|0.5;
_tsm_parnm = "phi1"|"sigma_u"|"theta1"|"sigma_v";
{coeff,stderr,Mcov,Logl} = FD_ml(z,&sgf,sv);

g = sgf(coeff,lambda);
q = trunc(rows(lambda)/2);

graphset;
  window3u;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2; 
  _pltype = 6; _plwidth = 8; 
  _paxht = 0.18; _pnumht = 0.18; _ptitlht = 0.30;

  setwind(1);
    title("\216Simulation de z]t[");
    _pcolor = 1;
    xtics(0,1000,100,2);
    ytics(-6,6,2,2);
    xy(0,z);

  setwind(2);
    title("\216Periodogramme I(\202l\201)");
    _pcolor = 2;
    xlabel("\216\202l\201");
    xtics(0,pi,pi/4,0);
    ytics(0,40,10,2);
    lab = " 0 \202p\201/4 \202p\201/2 \2013\202p\201/4 \202p\201";
    asclabel(lab,0);
    _pmsgstr = "-\000-";
    _pmsgctl = 2.88~6.37~0.10~45~2~0~5;
    xy(lambda[1:q],I[1:q]);

  setwind(3);
    title("\216Densite spectrale estimee f(\202l\201)");
    _pcolor = 3|4;
    _pmsgctl = 2.75~6.37~0.10~45~2~0~5 |
               6.75~6.37~0.10~45~2~0~5 ;
    xy(lambda[1:q],g[1:q]);

    graphprt("-c=1 -cf=ex6.eps");

  endwind;

proc sgf(coeff,lambda);
  local phi1,theta1,sigma_u,sigma_v;
  local w,g;
  phi1 = coeff[1];
  sigma_u = coeff[2];
  theta1 = coeff[3];
  sigma_v = coeff[4];
  w = cos(lambda);
  g = (sigma_u^2)./(1-2*phi1*w+phi1^2) +
      (sigma_v^2).*(1-2*theta1*w+theta1^2);
  retp(g);
endp;

